package multex; //Exc.java


//History:
//2001-04-19  Knabe  Now its possible to redefine the checkClass-method
//2001-04-19  Knabe  getUserInformation returns the default message text pattern
//                   and the message parameters, each on a separate line
//2001-04-15  Knabe  Convenience constructors with 1..9 Object-parameters added
//2001-04-14  Knabe  Again only unnamed exception parameters
//2000-10-06  Knabe  Require default message text pattern in the exception
//2000-09-29  Knabe  Allows only named parameters
//2000-09-28  Knabe  checkClass checks public-ness of the class, too
//2000-07-31  Knabe  getMessage() formats parameter as {i}=.. rather than [i]=..
//2000-06-29  Knabe  _cause gets type Exception rather than Throwable
//2000-06-19  Knabe  printStackTrace() bei Ursachenkette ohne Ausgabe
//                   von redundanten Zeilen.
//2000-06-12  Knabe  alle printStackTrace(...) ber printStackTrace(PrintWriter)
//1999-03-23  Knabe  Parametrierung wie in Java-Tutorial/i18n/format
//1999-03-12  Knabe  NEU: causingThrowable()
//1999-01-14  Knabe  erstellt

/**Problem-related exception with parameters and internationalizable
  message text.
  This class serves for the framework user as a base class for defining
  problem-related exceptions. It can be used to throw directly, too, but such
  exceptions cannot be handled individually nor get internationalized.

  <H2>Naming convention:</H2>
  All user-defined exception classes derived from Exc should have a name
  ending in Exc. The pattern is: <PRE>
    class ErrorconditionExc extends Exc { ... }
  </PRE>

  <H2>Parameters</H2>
  All elements of the Object[] are
  considered positional parameters of this exception. The corresponding
  placeholders in the message text patterns have the syntax: {i}
  with i being the number of the parameter in the range 0..9.
  <P>
  The exception parameters can
  be substituted into the corresponding message text pattern in a desired locale
  format by class {@link MsgText}, which itself makes use of class
  java.text.MessageFormat.
  <br>
  See the usage examples Copy, AwtCopy, SwingCopy in directory demo.

  <H2>Relation to Standards</H2>
  Class java.text.MesageFormat does much more in direction of internationalization
  than just to insert parameters into a message text pattern.
  You can e.g. specify different styles of formatting a parameter.
  E.g. formatting a parameter of type java.util.Date at position 0
  could be done by the following parameter formatting directive:
  {0,date}.

  <H2>Cause of a problem-related exception?</H2>
  The class Exc does not provide a constructor parameter for its cause,
  as it is usually found out testing a value.
  In the rare case, you want to give a cause to a business rule exception,
  you can provide it since JRE 1.4 after creation of the exception 
  object by Throwable.initCause().
  
  @author Christoph Knabe, TFH Berlin, 1999-2005
*/

public class Exc extends java.lang.Exception
implements MultexException {

/**The unqualified name of this class*/
public static final String className = "Exc";


private final String _defaultMessageTextPattern;

/**Positional parameters of this exception.*/
private final Object[] _parameters;

/**Convenience constructor null
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern){
  this((Object[])null, i_defaultMessageTextPattern);
}

/**Convenience constructor 0
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0
){
  this(new Object[]{
    i_object0
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 1
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1
){
  this(new Object[]{
    i_object0, i_object1
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 2
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2
){
  this(new Object[]{
    i_object0, i_object1, i_object2
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 3
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 4
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 5
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4, final Object i_object5
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4, i_object5
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 6
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4, final Object i_object5,
  final Object i_object6
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4, i_object5, i_object6
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 7
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4, final Object i_object5,
  final Object i_object6, final Object i_object7
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4, i_object5, i_object6,
    i_object7
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 8
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4, final Object i_object5,
  final Object i_object6, final Object i_object7, final Object i_object8
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4, i_object5, i_object6,
    i_object7, i_object8
  }, i_defaultMessageTextPattern);
}

/**Convenience constructor 9
  @see #Exc(String, Object[])
*/
public Exc(final String i_defaultMessageTextPattern,
  final Object i_object0, final Object i_object1, final Object i_object2,
  final Object i_object3, final Object i_object4, final Object i_object5,
  final Object i_object6, final Object i_object7, final Object i_object8,
  final Object i_object9
){
  this(new Object[]{
    i_object0, i_object1, i_object2, i_object3, i_object4, i_object5, i_object6,
    i_object7, i_object8, i_object9
  }, i_defaultMessageTextPattern);
}

/** Constructs an Exc with a default message text pattern
* and exception parameters as an polymorphic Object[].
* <P>Example of defining an exception with parameters: <PRE>
*  public static class StartedExc extends Exc {
*    public StartedExc(final String i_driver, final java.util.Date i_date){
*      super("Copy-driver {0}, version of {1,date} was started",
*        new Object[]{i_driver,i_date}
*      );
*    }
*  }
* </PRE>
  Instead of creating an Object[] yourself you can use the corresponding
  convenience constructors.
  
  	@param i_defaultMessageTextPattern The default message text pattern 
  	in the syntax of java.text.MessageFormat 
	or null, if message text patterns shall only be taken from a ResourceBundle
    @param i_parameters Exception parameters as an polymorphic Object[], 
    	which can be inserted into the message text pattern by placeholders {0} ... {9}.
        null is allowed here, if you do not want to provide exception parameters.
*/
public Exc(
  final String i_defaultMessageTextPattern, final Object[] i_parameters
){
	this(Util.clone(i_parameters), i_defaultMessageTextPattern);
}

/**Does not make a clone of i_parameters*/
private Exc(
	final Object[] i_parameters, final String i_defaultMessageTextPattern
){
  _defaultMessageTextPattern 
  = "".equals(i_defaultMessageTextPattern) ? null : i_defaultMessageTextPattern;
  _parameters = i_parameters;
  _checkClass();
}

public String getMessage(){return Util.getUserInformation(this);}

public boolean hasParameters(){
	return _parameters!=null && _parameters.length>0;
}

public Object[] getParameters(){return Util.clone(_parameters);}

public String getDefaultMessageTextPattern(){
  return _defaultMessageTextPattern;
}

/** Prints the chained, compact stack traces of this <code>Failure</code>
  object to the standard error stream
  <A HREF="http://java.sun.com/j2se/1.3/docs/api/java/lang/System.html#err">System.err</A>.
  @see #printStackTrace(java.io.PrintWriter)
*/
public void printStackTrace(){
    Msg.printStackTrace(this);
}

/** Prints the chained, compact stack traces of this <code>Failure</code>
  object to io_printer.
* @see #printStackTrace(java.io.PrintWriter)
*/
public void printStackTrace(final java.io.PrintStream io_printer) {
    Msg.printStackTrace(io_printer, this);
}

/** Prints the chained, compact stack traces of this <code>Failure</code>
  object to io_printer.
*/
public void printStackTrace(final java.io.PrintWriter io_printer) {
    //super.printStackTrace(io_printer);
    //Use the better MulTEX printStackTrace instead of the JRE ones:
    Msg.printStackTrace(io_printer, this);
}

/**Checks that the class of this object is OK.
  In the moment this means, that its name ends in {@link #className}
*/
private void _checkClass(){
  Util.checkClass(this, className);
}

}//Exc