package multex.test;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;

/**
 * @author administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public final class TestUtil extends Assert {

	/**Checks, that i_contained is contained in i_total*/
	public static void assertIsContained(final String i_contained, final String i_total)
	throws AssertionFailedError
	{
		if(i_total.indexOf(i_contained)<0){
			throw new AssertionFailedError(
				"Expected string <" + i_contained 
				+ "> was not contained in <" + i_total + ">."
			);
		}
	}

	/**Checks, that i_contained is the first part of i_total. */
	public static void assertIsStart(final String i_contained, final String i_total)
	throws AssertionFailedError
	{
		if(!i_total.startsWith(i_contained)){
			throw new AssertionFailedError(
				"Expected string <" + i_contained 
				+ "> is not the start of <" + i_total + ">."
			);
		}
	}

	/**Checks, that the arrays expected and got are both null, or have the same length 
	 * and each element equals to the corresponding.
	 * */
	public static void assertEquals(final Object[] i_expected, final Object[] i_got)
	throws AssertionFailedError
	{
		if(i_expected==i_got){return;}
		if(i_expected==null){fail("Expected array is null, but the array got not");}
		if(i_expected.length!=i_got.length){
			fail("Expected array has length " + i_expected.length 
				+ ", but array got has length " + i_got.length
			);
		}
		for(int i=0; i<i_expected.length; i++){
			assertEquals("Array element " + i, i_expected[i], i_got[i]);
		}
	}
	
	public static void assertLongStringEquals(
		final String i_expected, final String i_got
	){
		if(i_expected==i_got){return;}
		if(i_expected==null){fail("Expected String is null, but the String got not. It is <"+i_got+">");}
		if(i_expected.length()!=i_got.length()){
			fail("Expected String has length " + i_expected.length() 
				+ ", but array got has length " + i_got.length()
				+ "\nExpected: <" + i_expected + ">, got: <" + i_got + ">"
			);
		}
		for(int i=0; i<i_expected.length(); i++){
			assertEquals(
				"String character at index " + i + ": ", 
				i_expected.charAt(i), 
				i_got.charAt(i)
			);
		}
		
	}
}
